---
title: USBConfiguration
slug: Web/API/USBConfiguration
tags:
  - API
  - Interface
  - Reference
  - USB
  - USBConfiguration
  - WebUSB
  - WebUSB API
---
<p>{{securecontext_header}}{{DefaultAPISidebar("WebUSB API")}}</p>

<p>The <code>USBConfiguration</code> interface of the <a href="/en-US/docs/Web/API/WebUSB_API">WebUSB API</a> provides information about a particular configuration of a USB device and the interfaces that it supports.</p>

<h2 id="Constructor">Constructor</h2>

<dl>
	<dt>{{domxref("USBConfiguration.USBConfiguration()")}}</dt>
	<dd>Creates a new <code>USBConfiguration</code> object which contains information about the configuration on the provided <code>USBDevice</code> with the given configuration value.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<dl>
	<dt>{{domxref("USBConfiguration.configurationValue")}}{{readonlyInline}}</dt>
	<dd>Returns the configuration value of this configuration. This is equal to the <a href="https://www.beyondlogic.org/usbnutshell/usb5.shtml#ConfigurationDescriptors"><code>bConfigurationValue</code></a> field of the configuration descriptor provided by the device defining this configuration.</dd>
	<dt>{{domxref("USBConfiguration.configurationName")}}{{readonlyInline}}</dt>
	<dd>Returns the name provided by the device to describe this configuration. This is equal to the value of the string descriptor with the index provided in the <a href="https://www.beyondlogic.org/usbnutshell/usb5.shtml#ConfigurationDescriptors"><code>iConfiguration</code></a> field of the configuration descriptor defining this configuration.</dd>
	<dt>{{domxref("USBConfiguration.interfaces")}}{{readonlyInline}}</dt>
	<dd>Returns an array containing instances of the {{domxref('USBInterface')}} describing each interface supported by this configuration.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
		<tr>
			<td>{{SpecName('Web USB','#configurations','USBConfiguration')}}</td>
			<td>{{Spec2('Web USB')}}</td>
			<td>Initial definition.</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.USBConfiguration")}}</p>
